//
//  general.h
//  PS
//
//  Created by Bernard van Gastel on 22-11-11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#ifndef DLCHECKER_general_h
#define DLCHECKER_general_h

#include "datastructures.h"

extern int MAX_DESTS_PER_RESOURCE;

extern bool MIN_DL_NOT_NEC;
extern bool VERBOSE;
extern bool DO_NOT_CHK_R_OF_POS_DL;
extern bool REPORT180;
extern bool SMT;
extern bool LOCAL_MINIMA;
extern bool ASSEMBLE_STATISTICS;
extern bool MINIMIZE_RESOURCES;
extern bool output;
extern bool PS;


void zero_list(int *list, int n);
unsigned int log2alt(unsigned int v);
long long nCr(int n, int r);
long long min(long long x, long long y);
int num_of_cores();

#include DEFINITIONS

ResourceList *inst_routing(const Resource* c, const Procnode* d, const Params *dim);
int fill_graph(Graph *g, int*nodeset, ResourceList *faulty_resources, const Params *dim);
int PS_run_algorithm_on_faulty_configuration(ResourceList *faulty_resources, const Params *params);
int WHS_run_algorithm_on_faulty_configuration(ResourceList *faulty_resources, const Params *params);

void compute_parents (Graph *g, int *nodeset, int num_of_resources);
int check_reachability_possible_deadlock (Graph* g, Marks* marks, const Params* params, ResourceList* faulty_resources);


long long get_num_of_faulty_configurations(const Params *params);

Params *inst_params();
void run_algorithm_on_batch_of_faulty_configurations(long long start, long long end, struct RET_table* ret_table, const Params *params);
//int inst_num_of_resources(const Params *params);

#endif
