#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <ctype.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


int product(int* numbers, int size) {
	int ret = 1, i;
	for (i=0;i<size;i++)
		ret *= numbers[i];
	return ret;
}
char* tabs(int n) {
	char* ret = malloc((n+1) * sizeof(char));
	int i;
	for (i=0;i<n;i++)
		ret[i] = '\t';
	ret[n] = '\0';
	return ret;
}
char* firstn(char* str, int n) {
	char* ret = malloc((n+1) * sizeof(char));
	int i;
	for (i=0;i<n;i++)
		ret[i] = str[i];
	ret[n] = '\0';
	return ret;	
}

int main(int argc, char *argv[]) {
	if (argc != 2) {
		printf("Supply file with topology.\n");
		exit(0);
	}


	char file_topo[50];
	file_topo[0] = '\0';
	strcat(file_topo, argv[1]);
	strcat(file_topo, ".top");

	char file_out0[50];
	file_out0[0] = '\0';
	strcat(file_out0, argv[1]);
	strcat(file_out0, "_definitions.h");

	char file_out1[50];
	file_out1[0] = '\0';
	strcat(file_out1, argv[1]);
	strcat(file_out1, "_topology.cpp");

	char file_out2[50];
	file_out2[0] = '\0';
	strcat(file_out2, argv[1]);
	strcat(file_out2, "_faults.c");

	char argv1_upper[50];
	int i = 0;
	while (argv[1][i] != '\0') {
		argv1_upper[i] = toupper(argv[1][i]);
		i++;
	}

	FILE *file = fopen(file_topo, "r");
	if(file == NULL) {
		printf("%s does not exist.\n", file_topo);
	}
	else {
		int i =0 , NUM_OF_PROC_NODES = 1, num_of_p_fields, num_of_r_fields, j, num_of_faults=0;

		if (fscanf(file, "%i\n", &num_of_faults) == EOF)
			printf ("Syntax error\n");

		if (fscanf(file, "%i\n", &num_of_p_fields) == EOF)
			printf ("Syntax error\n");
		int range[num_of_p_fields];
		char p_field[num_of_p_fields][100]; 
		for (i=0;i<num_of_p_fields;i++)
			fscanf(file, "%s < %i;\n", p_field[i], &(range[i]));

		if (fscanf(file, "%i\n", &num_of_r_fields) == EOF)
			printf ("Syntax error\n");
		char r_field[num_of_r_fields][100];
		for (i=0;i<num_of_r_fields;i++)
			fscanf(file, "%s\n", r_field[i]);

		char topology_functions[2000], c;
		for (i=0;i<2000;i++)
			topology_functions[i] = '\0';
		i=0;
		while (fscanf(file, "%c", &c) != EOF) {
			topology_functions[i++] = c;
			assert(i<2000);
		}

		printf("Number of faults = %i\n", num_of_faults);
		printf ("Read the following processing node fields and ranges:\n"); 
		for (i=0;i<num_of_p_fields;i++) {
			NUM_OF_PROC_NODES *= range[i];
			printf("%s < %i\n", p_field[i], range[i]);
		}
		printf ("Read the following resource fields:\n"); 
		for (i=0;i<num_of_r_fields;i++)
			printf("%s; ", r_field[i]);
		puts("");



		/* Paranoia mode in: check if size of storing resource is under 31 bit */
		int bitsize_of_resource = 0;
		for (i=0;i<num_of_p_fields;i++)
			bitsize_of_resource += ceil(log2(range[i]+1));
		bitsize_of_resource += ceil(log2(num_of_r_fields+1));
		if (bitsize_of_resource > 31) {
			printf("Bit size of storing one resource is greater than 31 bits. The algorithm cannot reliably deal with this.\n");
			assert(0);
		}
		else			
			printf("Bit size of storing one resource = %i\n", bitsize_of_resource);
		/* Paranoia mode out */

		FILE *out = fopen(file_out0, "w");
		if (out == NULL) {
			printf("Cannot open file %s.\n", file_out0);
			exit(0);
		}

		fprintf(out, "#ifndef D%s_DEFINITIONS\n#define D%s_DEFINITIONS\n\n", argv1_upper, argv1_upper);
		fprintf(out, "#include <math.h>\n#include <stdlib.h>\n#include <stdio.h>\n#include \"memorycache.h\"\n#include <assert.h>\n\n\n");

		fprintf(out, "const int static INITIAL_NUM_OF_LABELS = 50;\n");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "const int static PARAM_%s = %i;\n", p_field[i], range[i]);
		fprintf(out, "const int static NUM_OF_PROC_NODES = %i;\n", product(range, num_of_p_fields));
		fprintf(out, "// DATA STRUCTURES\n/* Processing nodes and resources */\n");
		fprintf(out, "\nstruct Procnode {\n");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\tint %s;\n", p_field[i]);
		fprintf(out, "\tProcnode(");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "int %s = 0", p_field[i]);
			if (i<num_of_p_fields-1) fprintf(out, ", ");
		}
		fprintf(out, "): ");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "%s(%s)", p_field[i], p_field[i]);
			if (i<num_of_p_fields-1) fprintf(out, ", ");
		}
		fprintf(out, " {\n\t}\n");
		fprintf(out, "};\n");
		fprintf(out, "enum port {");
		for (i=0;i<num_of_r_fields;i++) {
			if (i > 0) fprintf(out, ", ");
			fprintf(out, "%s", r_field[i]);
		}
		fprintf(out, ",INVALID};\n");			

		fprintf(out, "\nclass Resource {\npublic:\n");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\tshort %s;\n", p_field[i]);
		fprintf(out, "\tchar p;\n\tbool b;\n\tResource() : ");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "%s(PARAM_%s), ", p_field[i], p_field[i]);
		}
		fprintf(out, "p(INVALID), b(false) {\n\t}\n\tResource(");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "unsigned short %s, ", p_field[i]);
		}
		fprintf(out, "port p, bool b = true) : ");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "%s(%s), ", p_field[i], p_field[i]);
		fprintf(out, "p(p), b(b) {\n\t}\n\tbool valid() const {\n\t\treturn ");
		for (i=0;i<num_of_p_fields;i++) {
			if (i > 0) fprintf(out, " && ");
			fprintf(out, "%s != PARAM_%s", p_field[i], p_field[i]);
		}
		fprintf(out, " && p != INVALID;\n");		
		fprintf(out, "\t}\n};\nstd::ostream &operator <<(std::ostream &out, const Resource &r);\n\n");

		fprintf(out, "class ResourceList {\npublic:\n\tResource *routed;\n\tResourceList(Resource routed[]) : routed(routed) {\n\t}\n\tvirtual ~ResourceList() {\n\t}\n\tResource &at(off_t i) {\n\t\treturn (*this)[i];\n\t}");
		fprintf(out, "\n\tResource &operator[](off_t i) {\n\t\treturn routed[i];\n\t}\n\tconst Resource &operator[](off_t i) const {\n\t\treturn routed[i];\n\t}\n};\n\ntemplate <int N>\nclass ResourceListN : public CacheInstances< ResourceListN<N> >, public ResourceList {\n");
		fprintf(out, "\tResource list[N];\npublic:\n\tResourceListN() : ResourceList(list) {\n\t\tfor (int i = 0; i < N; ++i)\n\t\t\tlist[i] = Resource();\n\t}\n};\nstd::ostream &operator <<(std::ostream &out, const ResourceList &e);\n\n");
		fprintf(out, "class garbage : public CacheInstances<garbage> {\n\tResource* elts[100];\n\tint num_of_elts;\npublic:\n\tgarbage() : num_of_elts(0) {\n\t}\n\t~garbage() {\n\t\tfor (int i=0;i<num_of_elts;i++) {\n\t\t\tif (elts != NULL)\n");
		fprintf(out, "\t\t\t\tdelete elts[i];\n\t\t}\n\t}\n\tvoid add(Resource *r) {\n\t\tassert(num_of_elts < 100);\n\t\telts[num_of_elts++] = r;\n\t}\n};\n");


		fprintf(out, "struct params {\n");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\tshort %s;\n", p_field[i]);
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\tshort %sLog2;\n", p_field[i]);
    	fprintf(out, "\tunsigned short bitsizeProcnodes;\n\tunsigned short bitsizeResources;\n};\ntypedef struct params Params;\n\n");

		fprintf(out, "int bitsize_of_resources(const Params* params);\n\n");

		fprintf(out, "Resource inst_convert_to_resource (int i, const Params* params);\nvoid inst_print_procnode(int i, const Params* params);\n");
		fprintf(out, "int inst_convert_resource_to_int (const Resource &r, const Params* params);\n");
		fprintf(out, "int inst_convert_procnode_to_int (Procnode* n, const Params *params);\n");
		fprintf(out, "Procnode get_end(const Resource &r);\n");
		fprintf(out, "void print_procnode(Procnode n, const Params *params);\n");
		fprintf(out, "ResourceList* inst_routing(const Resource &c, Procnode* d, const Params* dim, ResourceList* frs);\n");
		fprintf(out, "int is_faulty_resource(const Resource &r, ResourceList* faulty_resources);\n");
		fprintf(out, "int valid_resource(const Resource &r);\n");
		fprintf(out, "Procnode get_src(const Resource &r);\n");
		fprintf(out, "int equal_procnodes(Procnode p1, Procnode p2);\n");
		fprintf(out, "int bitsize_of_procnodes(const Params* params);\n");
		fprintf(out, "Procnode** inst_get_procnodes(const Params *params);\n");
		fprintf(out, "int inst_num_of_procnodes(const Params *params);\n");
		fprintf(out, "Resource inst_add_local_to_procnode(Procnode* p);\n");
		fprintf(out, "int equal_resources(const Resource &r1, const Resource &r2);\n");
		fprintf(out, "Procnode inst_convert_to_procnode (int i, const Params *params);\n");
		fprintf(out, "\n");
		fprintf(out, "#endif\n");

		fclose(out);
		printf("\nThe definitions file is stored in %s.\n", file_out0);

		out = fopen(file_out1, "w");
		if (out == NULL) {
			printf("Cannot open file %s.\n", file_out1);
			exit(0);
		}
		fprintf(out, "#include \"%s_definitions.h\"\n\n", argv[1]);

		fprintf(out, "%s\n\n\n", topology_functions);

		fprintf(out, "/********************************************\nFunctions required for processing nodes:\n*********************************************/\n");
		fprintf(out, "int inst_convert_procnode_to_int (Procnode* n, const Params *params) {\n\treturn ");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "(n->%s ", p_field[i]);
			if (i < num_of_p_fields-1) {
				fprintf(out, "<< (");
				for (j=i+1;j<num_of_p_fields;j++) {
					if (j>i+1) fprintf(out, " + ");
					fprintf(out, "params->%sLog2", p_field[j]);
				}
				fprintf(out, ")) | ");
			}
		}
		fprintf(out, ");\n}\n");

		fprintf(out, "Procnode inst_convert_to_procnode (int i, const Params *params) {\n");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "\tint %s = (i ", p_field[i]);
			if (i < num_of_p_fields-1) {
				fprintf(out, ">> (");
				for (j=i+1;j<num_of_p_fields;j++) {
					if (j>i+1) fprintf(out, " + ");
					fprintf(out, "params->%sLog2", p_field[j]);
				}
				fprintf(out, ")");
			}
			fprintf(out, ") & ((1 << params->%sLog2) - 1);\n", p_field[i]);
		}
		fprintf(out, "\treturn Procnode(");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "%s", p_field[i]);
			if (i < num_of_p_fields-1) fprintf(out, ",");
		}
		fprintf(out, ");\n}\n");

		fprintf(out, "// Returns the number of processing nodes\n");
		fprintf(out, "int inst_num_of_procnodes(const Params *params) {\n\treturn ");
		for (i=0;i<num_of_p_fields;i++) {
			if(i>0) fprintf(out, " * ");
			fprintf(out, "params->%s", p_field[i]);
		}
		fprintf(out, ";\n}\n");

		fprintf(out, "// Returns the size of storing a processing node:\nint bitsize_of_procnodes(const Params* params) {\n\treturn params->bitsizeProcnodes;\n}\n");

		fprintf(out, "// Returns a list of all processing nodes:\n");
		fprintf(out, "Procnode** inst_get_procnodes(const Params *params) {\n\tProcnode** ret = new Procnode*[inst_num_of_procnodes(params)];\n");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\tint %s;\n", p_field[i]);
		fprintf(out, "\tint n=0;\n");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\tfor(%s=0;%s<params->%s;%s++) {\n", p_field[i], p_field[i], p_field[i], p_field[i]);
		fprintf(out, "\t\tProcnode *p = (Procnode*) malloc(sizeof(Procnode));\n");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\t\tp->%s = %s;\n", p_field[i], p_field[i]);
		fprintf(out, "\t\tret[n++] = p;\n\t");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "}");
		fprintf(out, "\n\treturn ret;\n}\n");

		fprintf(out, "// Pretty printing:\nvoid print_procnode(Procnode n, const Params *params) {\n\tprintf(\"[");
		for (i=0;i<num_of_p_fields;i++) {
			if(i>0) fprintf(out, ",");
			fprintf(out, "%%i");
		}
		fprintf(out, "]\"");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, ", n.%s", p_field[i]);
		fprintf(out, ");\n}\n");

		fprintf(out, "void inst_print_procnode(int i, const Params* params) {\nprint_procnode(inst_convert_to_procnode(i,params), params);\n}\n");
		fprintf(out, "// Returns 1 iff the procnodes are equal\nint equal_procnodes(Procnode p1, Procnode p2) {\n\treturn (");
		for (i=0;i<num_of_p_fields;i++) {
			if (i>0) fprintf(out, " && ");
			fprintf(out, "p1.%s == p2.%s", p_field[i], p_field[i]);
		}
		fprintf(out, " ? 1 : 0);\n}\n");

		fprintf(out, "\n\n/********************************************\nFunctions required for resource:\n*********************************************/\n// Converts a resource to an int and reverse:\n");
		fprintf(out, "int inst_convert_resource_to_int (const Resource &r, const Params* params) {\n\tint p_int = ");
		for (i=0;i<num_of_r_fields-1;i++)
			fprintf(out, "(r.p == %s ? %i : ", r_field[i], i);
		fprintf(out, "%i", num_of_r_fields-1);
		for (i=0;i<num_of_r_fields-1;i++)
			fprintf(out, ")");
		fprintf(out, ";\n\treturn ");
		for (i=0;i<num_of_p_fields*2;i++)
			fprintf(out, "(");
		fprintf(out, "p_int ");

		for (i=0;i<num_of_p_fields;i++) 
			fprintf(out, "<< params->%sLog2) | r.%s) ", p_field[i], p_field[i]);
		fprintf(out, ";\n}\n");


		fprintf(out, "Resource inst_convert_to_resource (int i, const Params* params) {\n");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "\tint %s = (i ", p_field[i]);
			if (i < num_of_p_fields-1) {
				fprintf(out, ">> (");
				for (j=i+1;j<num_of_p_fields;j++) {
					if (j>i+1) fprintf(out, " + ");
					fprintf(out, "params->%sLog2", p_field[j]);
				}
				fprintf(out, ")");
			}
			fprintf(out, ") & ((1 << params->%sLog2) - 1);\n", p_field[i]);
		}
		fprintf(out, "\tport p = static_cast<port>((i ");
		fprintf(out, ">> (");
		for (j=0;j<num_of_p_fields;j++) {
			if (j>0) fprintf(out, " + ");
			fprintf(out, "params->%sLog2", p_field[j]);
		}
		fprintf(out, ")));\n");		

		fprintf(out, "\treturn Resource(");
		for (i=0;i<num_of_p_fields;i++) {
			fprintf(out, "%s", p_field[i]);
			if (i < num_of_p_fields-1) fprintf(out, ",");
		}
		fprintf(out, ",p,true);\n}\n");

		fprintf(out, "// Returns the number of resources:\nint bitsize_of_resources(const Params* params) {\n\treturn params->bitsizeResources;\n}\n");



		fprintf(out, "// Pretty printing:\nstd::ostream &operator <<(std::ostream &out, const Resource &r) {\n\tout << \"[\" << ");
		for (i=0;i<num_of_p_fields;i++) {
			if (i>0) fprintf(out, " << ");
			fprintf(out, "r.%s << \",\"", p_field[i]);
		}
    	fprintf(out, ";\n");
		for (i=0;i<num_of_r_fields;i++)
			fprintf(out, "\tif (r.p == %s) out << \"%s]\";\n", r_field[i], r_field[i]);
		fprintf(out, "\treturn out;\n}\n\n");


		fprintf(out, "std::ostream &operator <<(std::ostream &out, const ResourceList &rr) {\n\tout << \"[\";\n\tfor (int i = 0; rr[i].valid(); ++i) {\n\t\tout << rr[i];\n\t}\n\tout << \"]\";\n\treturn out;\n}\n\n");

		fprintf(out, "// Converts a processing node to the local-in resource of the processing node:\n");
		fprintf(out, "Resource inst_add_local_to_procnode(Procnode* p) {\n\treturn Resource(");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "p->%s, ", p_field[i]);
		fprintf(out, "L);\n}\n\n");

		fprintf(out, "// Returns 1 iff the resource is valid\nint valid_resource(const Resource &r) {\n");
		fprintf(out, "return (");
		for (i=0;i<num_of_p_fields;i++) {
			if (i > 0) fprintf(out, " && ");
			fprintf(out, "r.%s < PARAM_%s && r.%s >= 0", p_field[i], p_field[i], p_field[i]);
		}
		fprintf(out, " ? 1 : 0);\n}\n\n");

		fprintf(out, "// Returns 1 iff two resources are equal\nint equal_resources(const Resource &r1, const Resource &r2) {\n\treturn (");
		for (i=0;i<num_of_p_fields;i++) {
			if (i>0) fprintf(out, " && ");
			fprintf(out, "r1.%s == r2.%s", p_field[i],p_field[i]);
		}
		fprintf(out, " && r1.p == r2.p  ? 1 : 0);\n}\n");

		fprintf(out, "\nunsigned int log2alt(unsigned int v);\n\n");

		fprintf(out, "// Instantiate the params:\nParams* inst_params() {\n\tParams *retval = new Params();\n");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\tretval->%s = PARAM_%s;\n", p_field[i], p_field[i]);
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out, "\tretval->%sLog2 = log2alt(PARAM_%s) + 1;\n", p_field[i], p_field[i]);
		fprintf(out, "\tProcnode p(");
		for (i=0;i<num_of_p_fields;i++) {
			if (i > 0) fprintf(out, ",");
			fprintf(out, "PARAM_%s", p_field[i]);
		}
		fprintf(out, ");\n\tretval->bitsizeProcnodes = 1+inst_convert_procnode_to_int(&p,retval);\n\tResource r(");
		for (i=0;i<num_of_p_fields;i++) {
			if (i > 0) fprintf(out, ",");
			fprintf(out, "PARAM_%s", p_field[i]);
		}
		fprintf(out, ",L);\n\tretval->bitsizeResources = 1+inst_convert_resource_to_int(r,retval);\n\treturn retval;\n}\n");
	



		fclose(out);
		printf("The topology file is stored in %s.\n", file_out1);

		FILE *out2 = fopen(file_out2, "w");
		if (out2 == NULL) {
			printf("Cannot open file %s.\n", file_out2);
			exit(0);
		}
		fprintf(out2, "/**************/\n/* FAULTS     */\n/**************/\n\n");
		fprintf(out2, "#define num_of_faults %i\n", num_of_faults);
		fprintf(out2, "#include \"%s_definitions.h\"\n#include <assert.h>\n#include <signal.h>\n#include \"general.h\"\n\n", argv[1]);
		fprintf(out2, "extern bool ASSEMBLE_STATISTICS;\n\n");

		fprintf(out2, "long long get_num_of_faulty_configurations(const Params* params) {\n\tint num_of_channels = ");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out2, "params->%s*", p_field[i]);
		fprintf(out2, "L;\n\tlong long num_of_fms = nCr(num_of_channels, num_of_faults);\n\treturn num_of_fms;\n}\n\n");

		fprintf(out2, "bool is_last_resource(Resource r, const Params* params) {\n");
		fprintf(out2, "\treturn r.%s >= params->%s", p_field[0], p_field[0]);
		fprintf(out2, ";\n}\n\n");

		fprintf(out2, "Resource next_resource(Resource ret, const Params* params) {\n\tif (is_last_resource(ret,params))\n\t\treturn ret;\n");
		fprintf(out2, "\tif (ret.p == L-1) {\n\t\tret.p = 0;\n");

		for (i=num_of_p_fields-1;i>0;i--)
			fprintf(out2, "\t\t%sif (ret.%s == params->%s-1) {\n\t\t\t%sret.%s = 0;\n", tabs(num_of_p_fields-1-i), p_field[i], p_field[i], tabs(num_of_p_fields-1-i), p_field[i]);
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out2, "\t\t%sret.%s++;\n\t%s}%s%s%s\n\t%selse {\n", tabs(i==0?num_of_p_fields-1:num_of_p_fields-i), p_field[i], tabs(i==0?num_of_p_fields-1:num_of_p_fields-i),i==0?"":"\n", tabs(i==0?0:num_of_p_fields-i), i==0?"":"}", tabs(i==0?num_of_p_fields-1:num_of_p_fields-i-1));
		fprintf(out2, "\t\tret.p++;\n\t}\n\treturn ret;\n}\n");

		fprintf(out2, "Resource first_resource() {\n\treturn Resource(");
		for (i=0;i<num_of_p_fields;i++)
			fprintf(out2, "0,");
		fprintf(out2, "static_cast<port>(0));\n}\n");

 		int n, in = open("../generate_topology/faults_src_code", O_RDONLY);
		char buf[1024];
 		while((n = read(in, buf, sizeof(buf))) > 0)
			fprintf(out2, "%s", firstn(buf, n));

		fclose(out2);
		printf("The fault model file is stored in %s.\n", file_out2);
	}
	puts("");
	fclose(file);
	return 0;
}

