/****************************/
/* XY SHORTEST PATH ROUTING */
/****************************/

#include "2d_mesh_definitions.h"


// The routing function.
ResourceList* inst_routing(const Resource &c, Procnode* d, const Params* dim, ResourceList* frs) {
    ResourceList *hops = new ResourceListN<4>;
    Resource *nexthops = hops->routed;


	int i = 0;
	// The coordinates of the destination
	int dx = d->x, dy = d->y;
	// The coordinates of the processing node at the end of channel c
	int nx = get_end(c).x, ny = get_end(c).y;


	if (dx != nx || dy != ny) {					// If we do not arrive at our destination
		if (nx > 0 && dx < nx)
			nexthops[i++] = Resource(nx,ny,W);	//go west if the destination is west
		if (nx < (dim->x - 1) && dx > nx)
			nexthops[i++] = Resource(nx,ny,E);//go east if the destination is east
		if (ny > 0 && dy < ny)
			nexthops[i++] = Resource(nx,ny,N);//go north if the destination is north 
		if (ny < (dim->y - 1) && dy > ny)
			nexthops[i++] = Resource(nx,ny,S);//go south if the destination is south 
	}

	return hops;
}

