/**************/
/* DUATO CE   */
/**************/
#include "duato_ce_definitions.h"

ResourceList* inst_routing(const Resource &c, Procnode* d, const Params* dim, ResourceList* frs) {
    ResourceList *hops = new ResourceListN<3>;
    Resource *nexthops = hops->routed;


	// The destination
	int dx = d->x;
	// The coordinates of the processing node at the end of channel c
	int nx = get_end(c).x;

	if (dx != nx) {						// If we do not arrive at our destination
		if (dx < 6) {					// If the node is not d_0 or d_1, supply the dedicated channel
			switch (dx) {
				case 0: nexthops[0] = Resource(nx, to_n0); break;
				case 1: nexthops[0] = Resource(nx, to_n1); break;
				case 2: nexthops[0] = Resource(nx, to_n2); break;
				case 3: nexthops[0] = Resource(nx, to_n3); break;
				case 4: nexthops[0] = Resource(nx, to_n4); break;
				case 5: nexthops[0] = Resource(nx, to_n5); break;
				default: assert(false);
			}
		}
		else if (dx == 6) {				// If destination is d_0
			switch (nx) {
				case 0: nexthops[0] = Resource(nx, A); break;
				case 1: nexthops[0] = Resource(nx, C); nexthops[1] = Resource(nx, K); break;
				case 2: nexthops[0] = Resource(nx, J); break;
				case 3: nexthops[0] = Resource(nx, G); break;
				case 4: nexthops[0] = Resource(nx, E); break;
				case 5: nexthops[0] = Resource(nx, H); break;
				case 7: nexthops[0] = Resource(nx, to_d0); break;
				default: assert(false);
			}
		}
		else if (dx == 7) {				// If destination is d_1
			switch (nx) {
				case 0: nexthops[0] = Resource(nx, I); break;
				case 1: nexthops[0] = Resource(nx, C); nexthops[1] = Resource(nx, F); break;
				case 2: nexthops[0] = Resource(nx, B); break;
				case 3: nexthops[0] = Resource(nx, G); break;
				case 4: nexthops[0] = Resource(nx, D); break;
				case 5: nexthops[0] = Resource(nx, H); break;
				case 6: nexthops[0] = Resource(nx, to_d1); break;
				default: assert(false);
			}
		}
	}
	return hops;
}
